import { Badge } from "antd";
import { ColumnsType } from "antd/lib/table";
import React from "react";

const columnsLog = (): ColumnsType<any> => {

    const dataSource: ColumnsType<any> = [
        {
            title: 'ID',
            dataIndex: 'id',
            key: 'id',
            width: 50,
            align: 'center'
        },
        {
            title: '订单编号',
            dataIndex: 'orderNo',
            key: 'orderNo',
            width: 120,
            ellipsis: true
        },
        {
            title: '回传序号',
            dataIndex: 'backIndex',
            key: 'backIndex',
            width: 80,
            align: 'center'
        },
        {
            title: '拆分的回传金额',
            dataIndex: 'splitMoney',
            key: 'splitMoney',
            width: 100,
            align: 'center'
        },
        {
            title: '回传时间',
            dataIndex: 'backTime',
            key: 'backTime',
            width: 130,
            align: 'center',
            ellipsis: true
        },
        {
            title: '真实的回传时间',
            dataIndex: 'executeTime',
            key: 'executeTime',
            width: 130,
            align: 'center',
            ellipsis: true
        },
        {
            title: '回传状态',
            dataIndex: 'backStatus',
            key: 'backStatus',
            width: 90,
            align: 'center',
            render: (a: any) => {
                return a === -1 ? <Badge status="error" text="回传失败" /> : a === 0 ? <Badge status="warning" text="未回传" /> : a === 1 ? <Badge status="success" text="回传成功" /> : a === 2 ? <Badge status="default" text="部分成功" /> : '--'
            }
        },
        {
            title: '回传失败消息',
            dataIndex: 'backErrorMsg',
            key: 'backErrorMsg',
            ellipsis: true,
            width: 250
        },
    ];


    return dataSource

}


export default columnsLog